<div align="center">
  <br><br>
  <picture>
    <source media="(prefers-color-scheme: dark)" srcset="https://github.com/handsontable/handsontable/blob/develop/resources/handsontable-logo-white.svg?raw=true"/>
    <source media="(prefers-color-scheme: light)" srcset="https://github.com/handsontable/handsontable/blob/develop/resources/handsontable-logo-black.svg?raw=true"/>
    <img width="360" alt="Logo of Handsontable data grid" src="https://github.com/handsontable/handsontable/blob/develop/resources/handsontable-logo-black.svg?raw=true"/>
  </picture>
  <br><br>
  <h3>The official <img src="https://raw.githubusercontent.com/handsontable/handsontable/develop/resources/icons/react-icon.svg" width="16" height="16"> React <i>functional</i> wrapper for Handsontable.
    <br>
    <a href="https://handsontable.com/docs/react-data-grid" target="_blank">JavaScript Data Grid</a> with a spreadsheet-like look and feel.
  </h3>

  <p>With its spreadsheet-like editing features, it’s perfect for building data-rich internal apps. It allows users to enter, edit, validate, and process data from various sources. Common use cases include resource planning software (ERP), inventory management systems, digital platforms, and data modeling applications.</p>

<a href="https://handsontable.com">Website</a> &nbsp;&nbsp;—&nbsp;&nbsp; <a href="https://handsontable.com/docs/react-data-grid">Documentation</a> &nbsp;&nbsp;—&nbsp;&nbsp; <a href="https://handsontable.com/docs/react-data-grid/themes">Themes</a> &nbsp;&nbsp;—&nbsp;&nbsp; <a href="https://handsontable.com/docs/react-data-grid/api">API</a> &nbsp;&nbsp;—&nbsp;&nbsp; <a href="https://github.com/handsontable/handsontable/discussions">Community</a>

  <br>

[![NPM version](https://img.shields.io/npm/v/@handsontable/react-wrapper?style=for-the-badge)](https://npmjs.com/package/@handsontable/react-wrapper)
[![Total downloads](https://img.shields.io/npm/dt/handsontable.svg?style=for-the-badge)](https://npmjs.com/package/@handsontable/react-wrapper)
[![Monthly downloads](https://img.shields.io/npm/dm/handsontable.svg?style=for-the-badge)](https://npmjs.com/package/@handsontable/react-wrapper)
[![Contributors](https://img.shields.io/github/contributors/handsontable/handsontable?style=for-the-badge)](https://github.com/handsontable/handsontable/graphs/contributors)
<br>
[![CI status](https://github.com/handsontable/handsontable/actions/workflows/test.yml/badge.svg?branch=master)](https://github.com/handsontable/handsontable/actions/workflows/test.yml?query=branch%3Amaster)
[![Quality gate status](https://sonarcloud.io/api/project_badges/measure?project=handsontable_handsontable&metric=alert_status)](https://sonarcloud.io/dashboard?id=handsontable_handsontable)
[![FOSSA status](https://app.fossa.io/api/projects/git%2Bgithub.com%2Fhandsontable%2Fhandsontable.svg?type=shield)](https://app.fossa.io/projects/git%2Bgithub.com%2Fhandsontable%2Fhandsontable?ref=badge_shield)

  <br>

  <picture>
    <source media="(prefers-color-scheme: dark)" srcset="https://github.com/handsontable/handsontable/blob/develop/resources/handsontable-preview-dark-theme.png?raw=true"/>
    <source media="(prefers-color-scheme: light)" srcset="https://github.com/handsontable/handsontable/blob/develop/resources/handsontable-preview-light-theme.png?raw=true"/>
    <img width="780" alt="React data grid preview" src="https://github.com/handsontable/handsontable/blob/develop/resources/handsontable-preview-light-theme.png?raw=true"/>
  </picture>
</div>

## ✨ Key Features

&nbsp;&nbsp;✅&nbsp; [Built-in themes](https://handsontable.com/docs/react-data-grid/themes/) <br>
&nbsp;&nbsp;✅&nbsp; [Flexible API](https://handsontable.com/docs/react-data-grid/api/) <br>
&nbsp;&nbsp;✅&nbsp; [Virtualization](https://handsontable.com/docs/react-data-grid/row-virtualization/) <br>
&nbsp;&nbsp;✅&nbsp; [IME support](https://handsontable.com/docs/react-data-grid/ime-support/) <br>
&nbsp;&nbsp;✅&nbsp; [Internationalization](https://handsontable.com/docs/react-data-grid/language/) <br>
&nbsp;&nbsp;✅&nbsp; [RTL support](https://handsontable.com/docs/react-data-grid/layout-direction/) <br>
&nbsp;&nbsp;✅&nbsp; [Accessibility](https://handsontable.com/docs/react-data-grid/accessibility/) <br>
&nbsp;&nbsp;✅&nbsp; [Keyboard shortcuts](https://handsontable.com/docs/react-data-grid/keyboard-shortcuts/) <br>
&nbsp;&nbsp;✅&nbsp; [Sorting data](https://handsontable.com/docs/react-data-grid/rows-sorting/) <br>
&nbsp;&nbsp;✅&nbsp; [Filtering data](https://handsontable.com/docs/react-data-grid/column-filter/) <br>
&nbsp;&nbsp;✅&nbsp; [400 built-in formulas](https://handsontable.com/docs/react-data-grid/formula-calculation/) <br>
&nbsp;&nbsp;✅&nbsp; [Configurable selection](https://handsontable.com/docs/react-data-grid/selection/) <br>
&nbsp;&nbsp;✅&nbsp; [Data validation](https://handsontable.com/docs/react-data-grid/cell-validator/) <br>
&nbsp;&nbsp;✅&nbsp; [Conditional formatting](https://handsontable.com/docs/react-data-grid/conditional-formatting/) <br>
&nbsp;&nbsp;✅&nbsp; [Merged cells](https://handsontable.com/docs/react-data-grid/merge-cells/) <br>
&nbsp;&nbsp;✅&nbsp; [Pinned/frozen columns](https://handsontable.com/docs/react-data-grid/column-freezing/) <br>
&nbsp;&nbsp;✅&nbsp; [Hiding columns](https://handsontable.com/docs/react-data-grid/column-hiding/) <br>
&nbsp;&nbsp;✅&nbsp; [Right-click context menu](https://handsontable.com/docs/react-data-grid/context-menu/) <br>

<div id="installation">

## 🪄 Installation
Below is the installation guide for the React functional component.

### Install Handsontable from [npm](https://www.npmjs.com/package/@handsontable/react-wrapper) or [Yarn](https://yarnpkg.com/package/@handsontable/react-wrapper).

```bash
npm install handsontable @handsontable/react-wrapper
```

### Import CSS files

```jsx
// Base CSS rules
import 'handsontable/styles/handsontable.min.css';
// Main theme variables
import 'handsontable/styles/ht-theme-main.min.css';
```

### Register Handsontable's modules

```jsx
import { registerAllModules } from 'handsontable/registry';

registerAllModules();
```

### Use the `HotTable` component

The main Handsontable component is called `HotTable`.

```jsx
import { HotTable } from '@handsontable/react-wrapper';
```

To set Handsontable's [configuration options](https://handsontable.com/docs/react-data-grid/configuration-options), use `HotTable`'s props. For example:

```jsx
import { HotTable, HotColumn } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.min.css';
import 'handsontable/styles/ht-theme-main.min.css';

registerAllModules();

const ExampleComponent = () => {
  return (
    <div class="ht-theme-main-dark-auto">
      <HotTable
        data={[
          { company: 'Tagcat', country: 'United Kingdom', rating: 4.4 },
          { company: 'Zoomzone', country: 'Japan', rating: 4.5 },
          { company: 'Meeveo', country: 'United States', rating: 4.6 },
        ]}
        rowHeaders={true}
        colHeaders={true}
        navigableHeaders={true}
        tabNavigation={true}
        multiColumnSorting={true}
        headerClassName="htLeft"
        licenseKey="non-commercial-and-evaluation"
      >
        <HotColumn title="Company" data="company" width="100"></HotColumn>
        <HotColumn title="Country" data="country" width="170" type="dropdown" source={['United Kingdom', 'Japan', 'United States']}></HotColumn>
        <HotColumn title="Rating" data="rating" width="100" type="numeric"></HotColumn>
      </HotTable>
    </div>
  );
};
```

[![Static Badge](https://img.shields.io/badge/View%20live%20demo-1a42e8?style=for-the-badge)](https://handsontable.com/docs/react-data-grid/demo)

</div>

<br>

## 🚀 Resources

- [Website](https://handsontable.com)
- [Demo](https://handsontable.com/demo)
- [Documentation](https://handsontable.com/docs/react-data-grid)
- [npm](https://www.npmjs.com/package/@handsontable/react)
- [CDN](https://www.jsdelivr.com/package/npm/@handsontable/react-wrapper)
- [Forum](https://forum.handsontable.com/)
- [Blog](https://handsontable.com/blog)
- [Contact support team](https://handsontable.com/contact?category=technical_support)
- [Get a quote](https://handsontable.com/get-a-quote)

<br>

## 🤔 Is Handsontable a Data Grid or a Spreadsheet?

Handsontable is a data grid component written in JavaScript, not a spreadsheet. However, it brings in many features typically found in spreadsheet software. We designed it this way because spreadsheet-like patterns are often the most user-friendly when it comes to data entry and management.

### Spreadsheet-like features in Handsontable:

- Keyboard shortcuts compliant with either Google Sheets or Excel
- 400 spreadsheet formulas via native integration with [HyperFormula](https://github.com/handsontable/hyperformula)
- Keyboard navigation across headers that can be disabled, making only cells navigable
- TAB navigation across cells that can be disabled
- Built-in undo-redo functionality
- Powerful clipboard capabilities for copy-paste operations
- Ability to scroll the grid within the container (`div`) or window
- Data binding in the form of an array of objects or arrays of arrays
- Built-in cell editors like a date picker or dropdown list

At first glance, it might seem that a data table, spreadsheet, and data grid are just different names for the same thing - an interactive table displaying data. In reality, these tools serve different purposes and offer distinct functionalities, designed to meet specific needs. Handsontable sits comfortably in the data grid category while incorporating many of the best aspects of spreadsheet software.

<br>

## 🛟 Support

**We're here to help!**

If you're using Handsontable with a free, non-commercial license, you can:
- Join the conversation on [GitHub Discussions](https://github.com/handsontable/handsontable/discussions) to share ideas, suggest features, or discuss changes.
- Report any bugs you find on our [GitHub Issue Board](https://github.com/handsontable/handsontable/issues).
- Connect with other developers and find answers on our [Developer Forum](https://handsontable.com/forum).

If you have a commercial license, feel free to contact us directly at [support@handsontable.com](mailto:support@handsontable.com) or use our [contact form](https://handsontable.com/contact?category=technical_support).

<br>

## 📖 Licenses

Handsontable is available under two licensing options, allowing you to choose the one that best fits your needs. Each license comes with its own terms and conditions, as outlined below:

### ① Free license for non-commercial use, and evaluation purposes
This license is available for non-commercial purposes such as teaching, academic research, or evaluation. It allows you to use Handsontable free of charge under the terms specified in the non-commercial license agreement.
[Learn more here](https://github.com/handsontable/handsontable/blob/master/handsontable-non-commercial-license.pdf).

### ② Commercial license
For commercial use, a paid license is required. This license includes support and maintenance to ensure you get the most out of Handsontable. The commercial license can be purchased directly from Handsoncode or through an [authorized reseller](https://handsontable.com/resellers). See the [pricing page](https://handsontable.com/pricing) for details.

<br>

## 🔑 License Key

For projects covered by the free non-commercial license, simply use the phrase `'non-commercial-and-evaluation'` as your license key.

If you're using Handsontable in a project that supports commercial activities, you'll need to purchase a license key at [handsontable.com/pricing](https://handsontable.com/pricing). You can find more details in [our documentation](https://handsontable.com/docs/license-key/).

<br>

## 🙌 Contributing

Contributions are welcome, but before you make them, please read the [Contributing Guide](https://github.com/handsontable/handsontable/blob/develop/CONTRIBUTING.md) and accept the [Contributor License Agreement](https://goo.gl/forms/yuutGuN0RjsikVpM2).

<br>
<br>

Created and maintained by the [Handsontable Team](https://handsontable.com/team) 👋

---

© 2012 - 2025 Handsoncode
